package de.umr.ep.common;

import java.util.List;
import java.util.Map;

/**
 * Defines an abstract operation.
 *
 * @author Marc Seidemann
 */
public abstract class CustomOperation<O extends Comparable> {

    /**
     * Returns the type of the operation.
     *
     * @param s the input event schema
     * @return the output type
     */
    public abstract Attribute.DataType getType(List<Attribute> s);

    /**
     * Creates a deep copy of this operation.
     *
     * @return a copy of this operation
     */
    public abstract CustomOperation<O> clone();

}
