package de.umr.ep.conversions;


import de.umr.ep.common.Attribute;
import de.umr.ep.common.CustomOperation;

import java.util.List;

/**
 * A custom operation
 */
public class Conversion extends CustomOperation<Comparable> {

    protected Attribute.DataType sourceType;
    protected Attribute.DataType targetType;
    protected CustomOperation operation;

    public Conversion(CustomOperation operation, Attribute.DataType sourceType, Attribute.DataType targetType) {
        this.operation = operation;
        this.sourceType = sourceType;
        this.targetType = targetType;
    }

    public Attribute.DataType getSourceType() {
        return sourceType;
    }

    public Attribute.DataType getTargetType() {
        return targetType;
    }

    @Override
    public Attribute.DataType getType(List s) {
        return targetType;
    }

    @Override
    public CustomOperation clone() {
        return new Conversion(operation.clone(), sourceType, targetType);
    }

    public CustomOperation getOperation() {
        return operation;
    }
}

