package de.umr.ep.operators;

import de.umr.ep.common.Attribute;
import de.umr.ep.queryengine.LogicalOperator;
import de.umr.ep.queryengine.predicates.arithmetic.ArithmeticOperation;

import java.util.List;

/**
 * Created by seidemann on 24.01.2017.
 */
public class Within extends LogicalOperator {

    protected ArithmeticOperation start, end;
    protected LogicalOperator input;

    public Within(LogicalOperator input, ArithmeticOperation start, ArithmeticOperation end) {
        this.input = input;
        this.start = start;
        this.end = end;
    }

    @Override
    public List<Attribute> getSchema() {
        return input.getSchema();
    }

    @Override
    public void setInput(LogicalOperator input, int i) {
        if (i == 0)
            this.input = input;
        else
            throw new IndexOutOfBoundsException();
    }

    @Override
    public int getInputCount() {
        return 1;
    }

    @Override
    public LogicalOperator getInput(int i) {
        if (i == 0)
            return input;
        else
            throw new IndexOutOfBoundsException();
    }

    public ArithmeticOperation getStart() {
        return start;
    }

    public ArithmeticOperation getEnd() {
        return end;
    }
}
