package de.umr.ep.queryengine.predicates;

/**
 * Interface for boolean expressions.
 */
public interface BooleanExpression {

    /**
     * Returns the arity, i.e., the number of inputs of this expression.
     * @return the arity
     */
    int getArity();

    /**
     * Returns the expression's input at the given index.
     * @param i the index
     * @return the operator at the given index or null, if there is none
     */
    BooleanExpression getInput(int i);

    /**
     * Sets the input expression.
     *
     * @param i the index
     * @param expression the expression
     */
    void setInput(int i, BooleanExpression expression);
}
