package de.umr.ep.queryengine.predicates;

/**
 * LIKE comparison of two terms.
 * One term has to be a string pattern,
 * the other one has to be of type string.
 *
 * @author Marc Seidemann
 */
public class Like extends Comparison {

    /**
     * The pattern to compare with.
     */
    protected String pattern;
    /**
     * Stores whether the term to compare
     * the pattern with is the left argument.
     */
    protected boolean termLeft;

    /**
     * Creates the expression left LIKE right.
     *
     * @param left the left term
     * @param right the right term
     */
    public Like(Term left,Term right) {
        super(left,right);

    }

    @Override
    public String toString() {
        if (termLeft)
            return left.toString() + " LIKE " + pattern;
        else
            return pattern + " LIKE " + right.toString();
    }
}
