package de.umr.ep.queryengine.predicates.pattern;

import de.umr.ep.queryengine.predicates.Term;

/**
 * Models a reference to a bounded variable.
 *
 * @author Marc Seidemann
 */
public class Binding extends Term {

    /**
     * The name of the bound variable.
     */
    private String name;

    /**
     * Creates a variable reference for the given variable.
     *
     * @param name the name of the bound variable
     */
    public Binding(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    @Override
    public Term clone() {
        return new Binding(name);
    }

    @Override
    public String toString() {
        return name;
    }
}
