package de.umr.ep.queryengine.predicates.spatial;

import de.umr.ep.queryengine.predicates.Comparison;
import de.umr.ep.queryengine.predicates.Term;

/**
 * Created by seidemann on 24.01.2017.
 */
public class SpatialComparison extends Comparison {

    public static enum SpatialPredicate {
        CONTAINS,
        COVERED_BY,
        COVERS,
        CROSSES,
        DISJOINT,
        EQUALS,
        EQUALS_EXACT,
        INTERSECTS,
        OVERLAPS,
        TOUCHES,
        WITHIN
    }

    protected SpatialPredicate predicate;

    /**
     * Creates a new comparison for the given terms.
     *
     * @param left  the left term
     * @param right the right term
     */
    public SpatialComparison(SpatialPredicate predicate, Term left, Term right) {
        super(left, right);
        this.predicate = predicate;
    }

    public SpatialPredicate getPredicate() {
        return predicate;
    }
}
