/*
 * Copyright (c) 2016
 * Database Research Group, University of Marburg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.umr.ep.queryengine.predicates.spatial;

import de.umr.ep.queryengine.predicates.Predicate;
import de.umr.ep.queryengine.predicates.Term;

/**
 * Equals (&quot;isSimple(b)&quot;) predicate of one term.
 *
 * @author Stefanie Speichert, Nick Baer
 */
public class SpatialIsSimple extends Predicate {

    Term term;

    /**
     * Creates the expression isSimple(right).
     *
     * @param term term
     */
    public SpatialIsSimple(Term term) {
        this.term = term;
    }

    @Override
    public String toString() {
        return "(isSimple(" + term.toString() + ")";
    }

}

