package de.umr.ep.event;

import org.junit.Assert;
import org.junit.Test;

import de.umr.ep.common.Attribute;
import de.umr.ep.common.Attribute.DataType;

public class EventSchemaTest {

	@Test
	public void testEqualsObject() throws SchemaException {
		EventSchema es = new EventSchema( 
			new Attribute("X", DataType.DOUBLE),
			new Attribute("Y", DataType.SHORT),
			new Attribute("Z", DataType.STRING) );
		
		Assert.assertEquals(es, new EventSchema( 
				new Attribute("X", DataType.DOUBLE),
				new Attribute("Y", DataType.SHORT),
				new Attribute("Z", DataType.STRING) ));
		
		Assert.assertEquals(es, new EventSchema( 
				new Attribute("x", DataType.DOUBLE),
				new Attribute("y", DataType.SHORT),
				new Attribute("z", DataType.STRING) ));
		
		Assert.assertNotEquals(es, new EventSchema( 
				new Attribute("X", DataType.FLOAT),
				new Attribute("Y", DataType.SHORT),
				new Attribute("Z", DataType.STRING) ));
		
		Assert.assertNotEquals(es, new EventSchema( 
				new Attribute("X", DataType.DOUBLE),
				new Attribute("Y", DataType.SHORT),
				new Attribute("Z", DataType.STRING),
				new Attribute("A", DataType.LONG)));
		
	}

	@Test
	public void testToString() throws SchemaException {
		EventSchema es = new EventSchema( 
			new Attribute("X", DataType.DOUBLE),
			new Attribute("Y", DataType.SHORT),
			new Attribute("Z", DataType.STRING) );
		
		System.out.println(es);
	}

}
