package de.umr.jepc.v2.addons.epa.topk;

import java.util.Comparator;

public class SkybandTree<T> {
	
	class TreeNode<E> {
		private TreeNode<E> left;
		private TreeNode<E> right;
		private int rightChildren;
		private E value;
		
		public TreeNode(E value) {
			this.value = value;
		}
	}
	private Comparator<T> comp;
	private TreeNode<T> root;
	
	public SkybandTree(Comparator<T> comp) {
		this.comp = comp;
		this.root = null;
	}
	
	public int add(T value) {
		if(root == null) {
			root = new TreeNode<T>(value);
		} else {
			return add(root, value, 0);
		}
		return 0;
	}
	
	private int add(TreeNode<T> current, T value, int dc) {
		//Insert as right child
		if(comp.compare(value, current.value) > 0) {
			current.rightChildren++;
			if(current.right == null) {
				current.right = new TreeNode<T>(value);
				return dc;
			} else {
				return add(current.right, value, dc);
			}
		//Insert as left child
		} else if(comp.compare(value, current.value) < 0) {
			if(current.left == null) {
				current.left = new TreeNode<T>(value);
				return dc+current.rightChildren+1;
			} else {
				return add(current.left, value, dc + current.rightChildren+1);
			}
		}
		throw new RuntimeException("Identische Objekte eingefuegt");
	}
}
