package de.umr.jepc.v2.addons.epa.topk;

import de.umr.ep.event.Event;

public class TopKEvent implements Comparable<TopKEvent> {

	private final Event event;
	private long startW;
	private long endW;
	private double score;
	private final int id;
	private static int ids = 0;
	private int dc;

	public TopKEvent(Event event) {
		this.event = event;
		this.id = ids++;
		this.dc = 0;
	}

	public TopKEvent(Event event, long startW, long endW, double score) {
		this.event = event;
		this.startW = startW;
		this.endW = endW;
		this.id = ids++;
		this.score = score;
		this.dc = 0;
	}

	public long getStartW() {
		return startW;
	}

	public void setStartW(long startW) {
		this.startW = startW;
	}

	public long getEndW() {
		return endW;
	}

	public void setEndW(long endW) {
		this.endW = endW;
	}

	public Event getEvent() {
		return event;
	}

	public int getId() {
		return id;
	}

	public double getScore() {
		return score;
	}

	public void setScore(double score) {
		this.score = score;
	}

	public String toString() {
		return event.toString();
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TopKEvent other = (TopKEvent) obj;
		if (endW != other.endW)
			return false;
		if (id != other.id)
			return false;
		if (Double.doubleToLongBits(score) != Double.doubleToLongBits(other.score))
			return false;
		if (startW != other.startW)
			return false;
		return true;
	}

	@Override
	public int compareTo(TopKEvent emd) {
		if (this.getScore() > emd.getScore())
			return -1;
		if (this.getScore() < emd.getScore())
			return 1;
		if (this.getEvent().getT2() > emd.getEvent().getT2())
			return -1;
		if (this.getEvent().getT2() < emd.getEvent().getT2())
			return 1;
		if (this.getId() > emd.getId())
			return 1;
		if (this.getId() < emd.getId())
			return -1;
		return 0;
	}

	public int getDc() {
		return dc;
	}

	public void setDc(int dc) {
		this.dc = dc;
	}

	public int increaseDominanceCounter() {
		dc++;
		return dc;
	}
}
