/**
 * 
 */
package de.umr.jepc.v2.addons.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Stream;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.api.EPProvider;
import de.umr.jepc.v2.api.util.EventUtil;
import de.umr.jepc.v2.bridges.nat.NativeBridge;
import de.umr.jepc.v2.provider.def.DefaultEPProvider;

/**
 * @author Michael Körber
 *
 */
public abstract class UserDefinedEPATest {
    
    protected EPProvider provider;
    
    @Before
    public void setup() {
        provider = new DefaultEPProvider( new NativeBridge() );
    }
    
    @After
    public void tearDown() {
        provider.destroy();
    }
    
    public final void compareResults(List<Event> expected, List<Event> actual) {
        Assert.assertEquals("Number of received events incorrect", expected.size(), actual.size());
        
        Stream<Long> ts = actual.stream().map( e -> e.getT1() ).distinct().sorted();
        
        for ( Iterator<Long> ti = ts.iterator(); ti.hasNext(); ) {
            long t = ti.next();
            List<Event> actualSnapshot = new ArrayList<>();
            List<Event> expectedSnapshot = new ArrayList<>();
            
            actual.stream().filter( e -> e.getT1() == t ).forEach(actualSnapshot::add);
            expected.stream().filter( e -> e.getT1() == t ).forEach(expectedSnapshot::add);
            
            Assert.assertEquals("Snapshots sizes do not match!", expectedSnapshot.size(), actualSnapshot.size()); 
            
            int i = 1;
            for ( Event exp : expectedSnapshot ) {
                boolean found = false;
                for ( Event act : actualSnapshot ) {
                    found |= EventUtil.compareEvents(exp, act, 1e-10);
                }
                if ( !found )
                    System.out.println("SHIT!");
                
                Assert.assertTrue("Expected event (" + i + ") not found in actual results", found);
                i++;
            }
        }
    }

}
