package de.umr.jepc.v2.api.epa.aggregates;

import de.umr.jepc.v2.api.epa.window.Window;

/**
 * Calculates the average value on the given attribute for
 * all valid events. Validity is determined by the applied 
 * {@link Window}-EPA.
 * <br>
 * This aggregate may be applied to numeric attribtues only.
 * @author Michael Körber
 *
 */
public class Average extends Aggregate {

	private static final long serialVersionUID = 1L;

	/**
     * @param attributeIn The attribute to calculate the average on
     * @param attributeOut The name of the output attribute
     */
	public Average(String attributeIn, String attributeOut) {
		super(attributeIn, attributeOut);
	}

}
