package de.umr.jepc.v2.api.epa.pattern.regex;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class Regex implements Iterable<Pattern> {
	
	private final List<Pattern> pattern = new ArrayList<>();

	public Regex(Pattern... pattern) {
		this.pattern.addAll(Arrays.asList(pattern));
	}

	@Override
	public Iterator<Pattern> iterator() {
	    return pattern.iterator();
	}
	
    @Override
    public String toString() {
        return pattern.toString();
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((pattern == null) ? 0 : pattern.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        Regex other = (Regex) obj;
        if (pattern == null) {
            if (other.pattern != null)
                return false;
        } else if (!pattern.equals(other.pattern))
            return false;
        return true;
    }
}
