package de.umr.jepc.v2.api.expression.arithmetic.compund.numeric;

import de.umr.ep.common.Attribute.DataType;
import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.ArithmeticExpression;
import de.umr.jepc.v2.api.expression.base.AbstractExpression;

/**
 * Computes the cosine of x
 * @author Michael Körber
 *
 */
public class ATan2 extends AbstractExpression<ArithmeticExpression> implements ArithmeticExpression {

    /**
     * @param x the input
     */
	public ATan2( ArithmeticExpression y, ArithmeticExpression x  ) {
		super(y,x);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public DataType getDataType(EventSchema schema, Bindings bindings) throws IncompatibleTypeException {
		return DataType.DOUBLE;
	}
}
