package de.umr.jepc.v2.api.expression.arithmetic.compund.numeric;

import de.umr.ep.common.Attribute.DataType;
import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.ArithmeticExpression;
import de.umr.jepc.v2.api.expression.base.AbstractExpression;

/**
 * Computes |x|
 * @author Michael Körber
 *
 */
public class Abs extends AbstractExpression<ArithmeticExpression> implements ArithmeticExpression {

	/**
	 * @param x the input
	 */
	public Abs( ArithmeticExpression x ) {
		super(x);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public DataType getDataType(EventSchema schema, Bindings bindings) throws IncompatibleTypeException, SchemaException {
		DataType it = getInput(0).getDataType(schema, bindings);
		if ( it.isNumeric() )
			return it;
		else 
			throw new IncompatibleTypeException("Abs can only be applied to numeric types, input is of type: " + it);
	}
}
