package de.umr.jepc.v2.api.expression.arithmetic.compund.numeric;

import de.umr.ep.common.Attribute.DataType;
import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.ArithmeticExpression;
import de.umr.jepc.v2.api.expression.base.AbstractExpression;

/**
 * Computes a / b
 * @author Michael Körber
 *
 */
public class Divide extends AbstractExpression<ArithmeticExpression> implements ArithmeticExpression {

    /**
     * @param a the first input
     * @param b the second input
     */
	public Divide( ArithmeticExpression a, ArithmeticExpression b ) {
		super(a,b);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public DataType getDataType(EventSchema schema, Bindings bindings) throws IncompatibleTypeException {
		return DataType.DOUBLE;
	}
	
	@Override
    public String toString() {
        return "(" + getInput(0) + " / " + getInput(1) + ")";
    }
}
