package de.umr.jepc.v2.api.expression.arithmetic.compund.numeric;

import de.umr.ep.common.Attribute.DataType;
import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.ArithmeticExpression;
import de.umr.jepc.v2.api.expression.base.AbstractExpression;

/**
 * Computes a - b
 * @author Michael Körber
 *
 */
public class Subtract extends AbstractExpression<ArithmeticExpression> implements ArithmeticExpression {

    /**
     * @param a the first input
     * @param b the second input
     */
	public Subtract( ArithmeticExpression a, ArithmeticExpression b ) {
		super(a,b);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public DataType getDataType(EventSchema schema, Bindings bindings) throws IncompatibleTypeException, SchemaException {
		DataType l = getInput(0).getDataType(schema,bindings);
		DataType r = getInput(1).getDataType(schema,bindings);
		DataType gct = DataType.getGCT(l, r);
		return (gct.compareTo(DataType.INTEGER) < 0) ? DataType.INTEGER : gct;
	}

    @Override
    public String toString() {
        return "(" + getInput(0) + " - " + getInput(1) + ")";
    }
	
	
}
