package de.umr.jepc.v2.api.expression.predicate;

import de.umr.jepc.v2.api.expression.ArithmeticExpression;
import de.umr.jepc.v2.api.expression.Predicate;
import de.umr.jepc.v2.api.expression.base.AbstractExpression;

/**
 * Checks if the left input is less than the right one
 * @author Michael Körber
 *
 */
public class Between extends AbstractExpression<ArithmeticExpression> implements Predicate {

    /**
     * @param value the input expression
     * @param lower the lower bound
	 * @param upper the upper bound
     */
	public Between( ArithmeticExpression value, ArithmeticExpression lower, ArithmeticExpression upper ) {
		super(value,lower,upper);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		return "(" + getInput(0) + ") BETWEEN (" + getInput(1) + ") AND (" + getInput(2) + ")";
	}

}
