package de.umr.jepc.v2.api.expression.predicate;

import de.umr.jepc.v2.api.expression.ArithmeticExpression;
import de.umr.jepc.v2.api.expression.Predicate;
import de.umr.jepc.v2.api.expression.base.AbstractExpression;

/**
 * Compares two inputs for inequality.
 * @author Michael Körber
 *
 */
public class Unequal extends AbstractExpression<ArithmeticExpression> implements Predicate {

    /**
     * @param left the first input
     * @param right the second input
     */
	public Unequal( ArithmeticExpression left, ArithmeticExpression right ) {
		super(left,right);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		return "(" + getInput(0) + ") != (" + getInput(1) + ")";
	}
}
