package de.umr.jepc.v2.api.provider;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.EPA;

/**
 * Handle to a registered data-source. 
 * @author Michael Körber
 *
 */
public interface DataSource {
	
	/**
	 * @return the name of the represented event stream
	 */
	String getName();
	
	/**
	 * @return the event-schema of this stream
	 */
	EventSchema getSchema();
	
	/** 
	 * @return an EPA to use as input for queries
	 */
	EPA getEPA();
	
}
