package de.umr.jepc.v2.api.provider;

import de.umr.ep.event.Event;

/**
 * A sink may be attached to a running query and receives
 * all results produced by it. It is typically used to trigger actions
 * based on the received results.
 * @author Michael Körber
 *
 */
public interface EventSink {
	
	/**
	 * Invoked on every event leaving the query this sink is attached to.
	 * @param event the query-result
	 */
	void receiveEvent( final Event event );

}
