package de.umr.jepc.v2.api.provider;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.api.EPProvider;

/**
 * Handle to an external event stream. This is returned by the 
 * active {@link EPProvider} after successful registration of a stream. 
 * The handle may be used to push events into the engine or to remove
 * the stream.
 * @author Michael Körber
 *
 */
public interface ExternalStreamHandle extends DataSource {
	
	/**
	 * Pushes the given interval-event into the system
	 * @param event
	 */
	void pushEvent( Event event );

}
