package de.umr.jepc.v2.api.provider;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.EPProvider;


/**
 * Handle to a deployed query. This is returned by the active {@link EPProvider}
 * after successful deployment of a query. The handle may be used
 * to register {@link EventSink sinks} or to remove the query.
 * @author Michael Körber
 *
 */
public interface QueryHandle {
	
	/**
	 * @return the name of the represented query
	 */
	String getName();
	
	/**
	 * @return the schem of this query's result events
	 */
	EventSchema getOutputSchema();

}
