package de.umr.jepc.v2.api.util;

import java.util.ArrayList;
import java.util.List;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.api.provider.EventSink;

/**
 * A sink collecting all results in a list for later examination
 * @author Michael Körber
 *
 */
public class CollectingSink implements EventSink {
	
    /** The list of events received */
	private final List<Event> events = new ArrayList<>();

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void receiveEvent(Event event) {
		events.add(event);
	}
	
	/**
	 * @return The list of events received
	 */
	public List<Event> getEvents() {
		return events;
	}
	


}
