package de.umr.jepc.v2.api.util;

import java.io.PrintStream;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.api.provider.EventSink;

/**
 * A sink printing each event to the given {@link PrintStream}
 * @author Michael Körber
 *
 */
public class PrintingSink implements EventSink {
	
    /** The stream to print to */
	private final PrintStream stream;

	/** 
	 * Creates a new instance using {@link System#out} as stream
	 */
	public PrintingSink() {
		this(System.out);
	}
	
	/**
	 * Creates a new instance
	 * @param stream the stream to print events to
	 */
	public PrintingSink(PrintStream stream) {
		this.stream = stream;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void receiveEvent(Event event) {
		stream.println(event.toString());
	}

}
