package de.umr.jepc.v2.provider.def.handler;

import de.umr.ep.event.Event;
import de.umr.ep.event.impl.SimpleEvent;
import de.umr.jepc.v2.api.bridge.EventChannel;
import de.umr.jepc.v2.api.epa.Stream;
import de.umr.jepc.v2.api.provider.ExternalStreamHandle;
import de.umr.jepc.v2.api.provider.StreamHandle;

public class StreamHandler extends EPAHandler implements StreamHandle, ExternalStreamHandle {
	
	private final String name;
	
	public StreamHandler(String name, EventChannel channel) {
		super(new Stream(name));
		this.name = name;
		setResultChannel(channel);
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public void pushEvent(Object[] payload, long timestamp) {
		Event event = new SimpleEvent( payload, timestamp, timestamp + 1 );
		receive(event);
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void pushEvent(Event event) {
        receive(event);
    }

	/**
	 * @{inheritDoc}
	 */
	@Override
	public Stream getEPA() {
		return new Stream(this.name);
	}

}
