package de.umr.jepc.v2.bindings;

import de.umr.ep.common.Attribute.DataType;
import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Binding;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.expressions.arithmetic.EVArithmeticExpression;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.TranslatorException;

public class EVBinding extends Binding {
    
    private final EVArithmeticExpression<?> expression;
    
    public EVBinding( Binding b, EventSchema schema, Bindings bindings ) throws TranslatorException, IncompatibleTypeException, SchemaException {
        super(b.getName(),b.getValue());
        DataType dt = b.getValue().getDataType(schema,bindings);
        
        if ( dt.isNumeric() ) {
          this.expression = ExpressionTranslator.INSTANCE.translateNumericExpression(b.getValue(), schema, bindings);
        }
        else if ( dt == DataType.STRING ) {
            this.expression = ExpressionTranslator.INSTANCE.translateStringExpression(b.getValue(), schema, bindings);
        }
        else
            throw new IncompatibleTypeException("Type " + dt + " not supported in VariableBindings");
    }

    public EVArithmeticExpression<?> getExpression() {
        return expression;
    }
    
}
