package de.umr.jepc.v2.expressions.arithmetic.constant;

import de.umr.ep.common.Attribute.DataType;
import de.umr.ep.event.Event;
import de.umr.jepc.v2.bindings.BoundVariables;
import de.umr.jepc.v2.expressions.arithmetic.EVArithmeticExpression;

public abstract class EVConstant<T> implements EVArithmeticExpression<T> {

	private final T value;
	
	private final DataType type;

	public EVConstant(T value, DataType type) {
		this.value = value;
		this.type = type;
	}

	@Override
	public T eval(Event event, BoundVariables bindings) {
		return value;
	}

	@Override
	public DataType getType() {
		return type;
	}

}
