package de.umr.jepc.v2.expressions.arithmetic.numeric;

import java.util.HashMap;
import java.util.Map;

import de.umr.ep.common.Attribute.DataType;
import de.umr.jepc.v2.expressions.arithmetic.EVNumericExpression;

public class EVAbs extends EVUnaryNumericExpression {
	
	private static final Map<DataType,OperatorImpl<Number,Number>> IMPLS = new HashMap<>();
	
	static {
		IMPLS.put(DataType.BYTE, (Number x)->(byte)Math.abs(x.intValue()));
		IMPLS.put(DataType.SHORT, (Number x)->(short)Math.abs(x.intValue()));
		IMPLS.put(DataType.INTEGER, (Number x)->Math.abs(x.intValue()));
		IMPLS.put(DataType.LONG,    (Number x)->Math.abs(x.longValue()));
		IMPLS.put(DataType.FLOAT,   (Number x)->Math.abs(x.floatValue()));
		IMPLS.put(DataType.DOUBLE,  (Number x)->Math.abs(x.doubleValue()));
	}
	
	public EVAbs(EVNumericExpression input) {
		super(input, input.getType(), IMPLS.get(input.getType()));
	}

}
