package de.umr.jepc.v2.expressions.predicate.string;

import de.umr.jepc.v2.expressions.arithmetic.EVStringExpression;
import de.umr.jepc.v2.expressions.predicate.EVPredicate;
import de.umr.jepc.v2.expressions.util.EVAbstractTrinaryExpression;

public class EVStringBetween extends EVAbstractTrinaryExpression<String, String, String, Boolean> implements EVPredicate {

	public EVStringBetween(EVStringExpression value, EVStringExpression lower, EVStringExpression upper) {
		super(value, lower, upper, new OperatorImpl<String, String, String, Boolean>() {

			@Override
			public Boolean apply(String v, String l, String u) {
				return l.compareTo(v) <= 0 && u.compareTo(v) >= 0;
			}
		});
	}

}
