package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.ASin;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVASin;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class ASinTranslator extends Translator<ASin, EVASin> {

	public ASinTranslator() {
		super(ASin.class, EVASin.class);
	}

	@Override
	protected EVASin process(ASin in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVASin(translator.translateNumericExpression(in.getInput(0), schema, bindings));
	}

}
