package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.ATan2;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVATan2;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class ATan2Translator extends Translator<ATan2, EVATan2> {

	public ATan2Translator() {
		super(ATan2.class, EVATan2.class);
	}

	@Override
	protected EVATan2 process(ATan2 in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVATan2(translator.translateNumericExpression(in.getInput(0), schema, bindings),
		                   translator.translateNumericExpression(in.getInput(1), schema, bindings));
	}

}
