package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.ATan;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVATan;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class ATanTranslator extends Translator<ATan, EVATan> {

	public ATanTranslator() {
		super(ATan.class, EVATan.class);
	}

	@Override
	protected EVATan process(ATan in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVATan(translator.translateNumericExpression(in.getInput(0), schema, bindings));
	}

}
