package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.Divide;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVDivide;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class DivideTranslator extends Translator<Divide, EVDivide> {

	public DivideTranslator() {
		super(Divide.class, EVDivide.class);
	}

	@Override
	protected EVDivide process(Divide in, ExpressionTranslator translator, EventSchema schema, Bindings bindings) throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVDivide(
				translator.translateNumericExpression(in.getInput(0), schema, bindings), 
				translator.translateNumericExpression(in.getInput(1), schema, bindings));
	}

}
