package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.Exp;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVExp;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class ExpTranslator extends Translator<Exp, EVExp> {

	public ExpTranslator() {
		super(Exp.class, EVExp.class);
	}

	@Override
	protected EVExp process(Exp in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVExp(translator.translateNumericExpression(in.getInput(0), schema, bindings));
	}

}
