package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.Multiply;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVMult;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class MultTranslator extends Translator<Multiply, EVMult> {

	public MultTranslator() {
		super(Multiply.class, EVMult.class);
	}

	@Override
	protected EVMult process(Multiply in, ExpressionTranslator translator, EventSchema schema, Bindings bindings) throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVMult(
				translator.translateNumericExpression(in.getInput(0), schema, bindings), 
				translator.translateNumericExpression(in.getInput(1), schema, bindings));
	}

}
