package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.Sqrt;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVSqrt;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class SqrtTranslator extends Translator<Sqrt, EVSqrt> {

	public SqrtTranslator() {
		super(Sqrt.class, EVSqrt.class);
	}

	@Override
	protected EVSqrt process(Sqrt in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVSqrt(translator.translateNumericExpression(in.getInput(0), schema, bindings));
	}

}
