package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.Subtract;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVSub;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class SubTranslator extends Translator<Subtract, EVSub> {

	public SubTranslator() {
		super(Subtract.class, EVSub.class);
	}

	@Override
	protected EVSub process(Subtract in, ExpressionTranslator translator, EventSchema schema, Bindings bindings) throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVSub(
				translator.translateNumericExpression(in.getInput(0), schema, bindings), 
				translator.translateNumericExpression(in.getInput(1), schema, bindings));
	}

}
