package de.umr.jepc.v2.ql.impl.arithmetic.numeric;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.compund.numeric.Tan;
import de.umr.jepc.v2.expressions.arithmetic.numeric.EVTan;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class TanTranslator extends Translator<Tan, EVTan> {

	public TanTranslator() {
		super(Tan.class, EVTan.class);
	}

	@Override
	protected EVTan process(Tan in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException, IncompatibleTypeException, SchemaException {
		return new EVTan(translator.translateNumericExpression(in.getInput(0), schema, bindings));
	}

}
