package de.umr.jepc.v2.ql.impl.atomic;

import org.kohsuke.MetaInfServices;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.atomic.DoubleConstant;
import de.umr.jepc.v2.expressions.arithmetic.constant.EVDoubleConstant;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class DoubleConstantTranslator extends Translator<DoubleConstant, EVDoubleConstant> {

	public DoubleConstantTranslator() {
		super(DoubleConstant.class, EVDoubleConstant.class);
	}

	@Override
	protected EVDoubleConstant process(DoubleConstant in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException {
		return new EVDoubleConstant(in.getValue());
	}

}
