package de.umr.jepc.v2.ql.impl.atomic;

import org.kohsuke.MetaInfServices;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.atomic.FloatConstant;
import de.umr.jepc.v2.expressions.arithmetic.constant.EVFloatConstant;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class FloatConstantTranslator extends Translator<FloatConstant, EVFloatConstant> {

	public FloatConstantTranslator() {
		super(FloatConstant.class, EVFloatConstant.class);
	}

	@Override
	protected EVFloatConstant process(FloatConstant in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException {
		return new EVFloatConstant(in.getValue());
	}

}
