package de.umr.jepc.v2.ql.impl.atomic;

import org.kohsuke.MetaInfServices;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.atomic.IntConstant;
import de.umr.jepc.v2.expressions.arithmetic.constant.EVIntConstant;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class IntConstantTranslator extends Translator<IntConstant, EVIntConstant> {

	public IntConstantTranslator() {
		super(IntConstant.class, EVIntConstant.class);
	}

	@Override
	protected EVIntConstant process(IntConstant in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException {
		return new EVIntConstant(in.getValue());
	}

}
