package de.umr.jepc.v2.ql.impl.atomic;

import org.kohsuke.MetaInfServices;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.atomic.LongConstant;
import de.umr.jepc.v2.expressions.arithmetic.constant.EVLongConstant;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class LongConstantTranslator extends Translator<LongConstant, EVLongConstant> {

	public LongConstantTranslator() {
		super(LongConstant.class, EVLongConstant.class);
	}

	@Override
	protected EVLongConstant process(LongConstant in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException {
		return new EVLongConstant(in.getValue());
	}

}
