package de.umr.jepc.v2.ql.impl.atomic;

import org.kohsuke.MetaInfServices;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.atomic.StringConstant;
import de.umr.jepc.v2.expressions.arithmetic.constant.EVStringConstant;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class StringConstantTranslator extends Translator<StringConstant, EVStringConstant> {

	public StringConstantTranslator() {
		super(StringConstant.class, EVStringConstant.class);
	}

	@Override
	protected EVStringConstant process(StringConstant in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException {
		return new EVStringConstant(in.getValue());
	}

}
