package de.umr.jepc.v2.ql.impl.atomic;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.Attribute.DataType;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.arithmetic.atomic.Variable;
import de.umr.jepc.v2.expressions.arithmetic.field.EVStringField;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class StringVariableTranslator extends Translator<Variable,EVStringField> {

	public StringVariableTranslator() {
		super(Variable.class, EVStringField.class);
	}

	@Override
	protected EVStringField process(Variable in, ExpressionTranslator translator, EventSchema schema, Bindings bindings)
			throws TranslatorException, SchemaException {
		
		int index = schema.getAttributeIndex(in.getName());
		if ( schema.byName(in.getName()).getType() == DataType.STRING )
			return new EVStringField(index);
		else
			throw new TranslatorException("Not a string-attribute: " + in.getName() );
		
		
	}

}
