package de.umr.jepc.v2.ql.impl.bool;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.logical.And;
import de.umr.jepc.v2.expressions.bool.EVAnd;
import de.umr.jepc.v2.expressions.bool.EVBooleanExpression;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class AndTranslator extends Translator<And, EVAnd> {

	public AndTranslator() {
		super(And.class, EVAnd.class);
	}
	
	@Override
	protected EVAnd process(And in, ExpressionTranslator translator, EventSchema schema, Bindings bindings) throws TranslatorException, IncompatibleTypeException, SchemaException {
		EVBooleanExpression left  = translator.translateBooleanExpression(in.getInput(0), schema, bindings);
		EVBooleanExpression right = translator.translateBooleanExpression(in.getInput(1), schema, bindings);
		return new EVAnd(left, right);
	}
}
