package de.umr.jepc.v2.ql.impl.bool;

import org.kohsuke.MetaInfServices;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.api.expression.logical.Not;
import de.umr.jepc.v2.expressions.bool.EVBooleanExpression;
import de.umr.jepc.v2.expressions.bool.EVNot;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.Translator;
import de.umr.jepc.v2.ql.TranslatorException;

@MetaInfServices
public class NotTranslator extends Translator<Not, EVNot> {

	public NotTranslator() {
		super(Not.class, EVNot.class);
	}
	
	@Override
	protected EVNot process(Not in, ExpressionTranslator translator, EventSchema schema, Bindings bindings) throws TranslatorException, IncompatibleTypeException, SchemaException {
		EVBooleanExpression evin = translator.translateBooleanExpression(in.getInput(0), schema, bindings);
		return new EVNot(evin);
	}
}
