/**
 * 
 */
package de.umr.jepc.v2.federated.api.epa;

import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.epa.EPA;
import de.umr.jepc.v2.api.epa.Stream;

/**
 * @author Michael Körber
 *
 */
public class QualifiedStream implements EPA {
    
    private static final long serialVersionUID = 1L;

    private final String qualifier;
    
    private final Stream stream;
    
    public QualifiedStream( String qualifier, Stream stream ) {
        this.qualifier = qualifier;
        this.stream = stream;
    }

    public String getQualifier() {
        return qualifier;
    }

    public Stream getStream() {
        return stream;
    }

    @Override
    public EPA[] getInputEPAs() {
        return new EPA[] { stream };
    }

    @Override
    public void setInput(int idx, EPA input) {
        throw new UnsupportedOperationException("Rebase of Qualified Stream not permitted");
    }

    @Override
    public EventSchema computeOutputSchema(EventSchema... inputSchemas) throws SchemaException {
        return inputSchemas[0];
    }

    @Override
    public int getDepth() {
        return stream.getDepth();
    }

    @Override
    public String toString() {
        return "QualifiedStream [qualifier=" + qualifier + ", stream=" + stream + "]";
    }
}
