/**
 * 
 */
package de.umr.jepc.v2.federated.api.resource;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.federated.api.provider.Resource;

/**
 * Interface for passing events from one {@link Resource} to another.
 * An implementation might use direct method calls for centralized federated systems
 * or sockets for distributed setups.
 * 
 * @author Michael Körber
 *
 */
public interface RemoteEventChannel {
    
    /**
     * Sends the given event to the designated end-point.
     * @param event the event to send
     */
    void pushEvent( Event event );

}
