/**
 * 
 */
package de.umr.jepc.v2.federated.api.provider;

import java.util.ArrayList;
import java.util.List;

import de.umr.jepc.v2.api.schema.StreamInfo;
import de.umr.jepc.v2.federated.api.provider.Resource;

/**
 * @author Michael Körber
 *
 */
public class TestResource implements Resource {
	
	private final String id;
	
	private final List<StreamInfo> streams = new ArrayList<>();
	

	/**
	 * @param id
	 */
	public TestResource(String id, StreamInfo... streams) {
		this.id = id;
		for ( StreamInfo si : streams )
			this.streams.add(si);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getIdentifier() {
		return id;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<StreamInfo> getProvidedStreams() {
		return streams;
	}
}
