package de.umr.jepc.v2.bridges.nat.epa.impl.filter;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.Event;
import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.bridge.EPACallback;
import de.umr.jepc.v2.api.bridge.EventChannel;
import de.umr.jepc.v2.api.epa.Filter;
import de.umr.jepc.v2.api.epa.pattern.symbol.Bindings;
import de.umr.jepc.v2.bridges.nat.epa.NativeOperator;
import de.umr.jepc.v2.expressions.bool.EVBooleanExpression;
import de.umr.jepc.v2.ql.ExpressionTranslator;
import de.umr.jepc.v2.ql.TranslatorException;

public class NativeFilter implements NativeOperator {
	
	private final EventSchema schema;
	
	private final EVBooleanExpression condition;
	
	private EPACallback callback;
	
	public NativeFilter(Filter def, EventChannel input) throws TranslatorException, IncompatibleTypeException {
		this.schema = def.computeOutputSchema(input.getSchema());
		this.condition = new ExpressionTranslator().translateBooleanExpression(def.getCondition(), input.getSchema(), new Bindings());
		
	}

	@Override
	public void process(EventChannel input, Event event) {
		if ( condition.eval(event) )
			callback.receive(event);
	}

	@Override
	public void setCallback(EPACallback callback) {
		this.callback = callback;
	}

	@Override
	public EventSchema getSchema() {
		return schema;
	}

}
