package de.umr.jepc.v2.bridges.nat.epa.impl.pattern;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.Event;
import de.umr.ep.event.EventSchema;
import de.umr.ep.event.SchemaException;
import de.umr.jepc.v2.api.bridge.EPACallback;
import de.umr.jepc.v2.api.bridge.EventChannel;
import de.umr.jepc.v2.api.epa.PatternMatcher;
import de.umr.jepc.v2.api.epa.pattern.symbol.DuplicateBindingException;
import de.umr.jepc.v2.api.epa.pattern.symbol.NoSuchVariableException;
import de.umr.jepc.v2.bridges.nat.epa.NativeOperator;

public class NativePatternMatcher implements NativeOperator {
	
	private final EventSchema schema;
	
    private EPACallback callback;
	
	public NativePatternMatcher(PatternMatcher def, EventChannel input) throws NoSuchVariableException, SchemaException, IncompatibleTypeException, DuplicateBindingException {
		this.schema = def.computeOutputSchema(input.getSchema());
	}
	
	@Override
	public void process(EventChannel input, Event event) {
	    //TODO: Implement
	    callback.receive( event );
	}

	@Override
	public void setCallback(EPACallback callback) {
		this.callback = callback;
	}

	@Override
	public EventSchema getSchema() {
		return schema;
	}

}
