/*
 * Copyright (c) 2012, 2013, 2014
 * Database Research Group, University of Marburg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.umr.jepc.v2.bridges.nat.epa.impl.window;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.api.bridge.EventChannel;
import de.umr.jepc.v2.api.epa.window.TimeWindow;

/**
 * Implements a time-based window
 * 
 * @author Michael Körber
 *
 */
public class NativeTimeWindow extends NativeWindow {

  public NativeTimeWindow(EventChannel input, TimeWindow def) {
    super(input, def);
  }

  /**
   * @{inheritDoc
   */
  @Override
  public void process(EventChannel input, Event event) {
	long t1 = (event.getT1() / jump) * jump;
	long t2 = ((event.getT1() + size) / jump) * jump;
	if ( t2 != t1 )
	    callback.receive( event.window(t1, t2) );
  }

}
