/*
 * Copyright (c) 2012, 2013, 2014
 * Database Research Group, University of Marburg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.umr.jepc.v2.bridges.nat.epa.util;

import java.util.Comparator;

import de.umr.ep.event.Event;

/**
 * Simple comparator for timestamps on events
 * @author Michael Körber
 */
public class AscTimestampComparator implements Comparator<Event> {

  @Override
  public int compare(Event e1, Event e2) {
    return Long.compare(e1.getT1(), e2.getT1());
  }

}
