package de.umr.jepc.v2.bridges.nat.epn;

import java.util.ArrayList;
import java.util.List;

import de.umr.ep.event.Event;
import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.api.bridge.EventChannel;

public class StreamNode implements EventChannel {

	private final List<OperatorNode> successors = new ArrayList<>();
	
	private final EventSchema schema;
	
	public StreamNode( EventSchema schema ) {
		this.schema = schema;
	}
	
	public EventSchema getSchema() {
		return schema;
	}

	public void addSuccessor( OperatorNode node ) {
		successors.add(node);
	}
	
	public boolean removeSuccessor( OperatorNode node ) {
		return successors.remove(node);
	}
	
	public boolean hasSuccessor() {
		return !successors.isEmpty();
	}
	
	@Override
	public void push(Event event) {
		for ( OperatorNode n : successors )
			n.process(this, event);
	}
}
