package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util;

import de.umr.jepc.v2.addons.epa.tpstream.Constraints;
import de.umr.jepc.v2.addons.epa.tpstream.Situation;
import de.umr.jepc.v2.addons.epa.tpstream.SituationDefinitions;
import de.umr.jepc.v2.addons.epa.tpstream.matcher.FixedDFSMatcher;
import de.umr.jepc.v2.addons.epa.tpstream.matcher.Matcher;
import de.umr.jepc.v2.addons.epa.tpstream.optimizer.Optimizer;

public class MatcherWrapper implements Matcher {

    public final long       window;

    public long             results;

    private final Matcher   matcher;

    private MatcherCallback cb = new MatcherCallback() {

                                   @Override
                                   public void onResult(Situation[] result, long currentTime) {
                                       results++;
                                   }

                               };

    public MatcherWrapper(SituationDefinitions ss, Constraints cs, long window) {
        Optimizer opt = new Optimizer(cs);
        this.window = window;
        this.matcher = new FixedDFSMatcher(ss, cs, window, opt, cb);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void update(Situation[] intervals, long windowStart) {
        matcher.update(intervals, windowStart);
    }
}