/**
 * 
 */
package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.adapter;

import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.EVUtil;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.MatcherWrapper;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.SituationGenerator;

/**
 * @author Michael Körber
 *
 */
public class MatcherAdapter implements EngineAdapter {

    private final MatcherWrapper matcher;
    
    private final SituationGenerator gen;
    
    
    public MatcherAdapter(SituationGenerator gen, MatcherWrapper wrapper) {
        this.gen = gen;
        this.matcher = wrapper;
    }
    
    public void run() {
        EVUtil.feedMatcher(gen, matcher, matcher.window);
    }
    
    public long getNumberOfResults() {
        return matcher.results;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void destroy() {
    }
  

}
