package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.adapter;

import org.wso2.siddhi.core.ExecutionPlanRuntime;
import org.wso2.siddhi.core.SiddhiManager;
import org.wso2.siddhi.core.event.Event;
import org.wso2.siddhi.core.stream.input.InputHandler;
import org.wso2.siddhi.core.stream.output.StreamCallback;

import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.SituationGenerator;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.situations.Situation;

public class SiddhiAdapter implements EngineAdapter {
	
    private final SiddhiManager siddhiManager;
    
	private final SituationGenerator gen;
	
	private final InputHandler handler;
	
	private long results = 0;
	
	public SiddhiAdapter(SituationGenerator gen, String query) {
		siddhiManager = new SiddhiManager();
		
		String sdef = "define stream " + gen.getName() + " (TYPE int, TSTART long, TEND long);";
		String plan = sdef + "\n" + query + "\n insert into " + gen.getName() + "Out;";
		
		ExecutionPlanRuntime rt = siddhiManager.createExecutionPlanRuntime(plan);
				
		//define stream
		rt.addCallback( gen.getName() + "Out", new StreamCallback() {
		     public void receive(Event[] events) {
//		          EventPrinter.print(events);
		          results+=events.length;
		     }
		});
		this.gen = gen;
		this.handler = rt.getInputHandler(gen.getName());
	}
	
	public long getNumberOfResults() {
		return results;
	}
	
	public void run() {
		try {
			while ( gen.hasNext() ) {
				Situation s = gen.next();
				handler.send(new Event(s.interval.getEnd(), new Object[] {s.idx,s.interval.getStart(),s.interval.getEnd()}));
			}
		} catch ( InterruptedException ire ) {
			throw new RuntimeException(ire);
		}
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void destroy() {
        siddhiManager.shutdown();
    }
}
