/**
 * 
 */
package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.adapter;

import de.umr.ep.common.EPException;
import de.umr.jepc.v2.addons.epa.TPStream;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.CountingSink;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.EventGenerator;
import de.umr.jepc.v2.api.EPProvider;
import de.umr.jepc.v2.api.provider.ExternalStreamHandle;
import de.umr.jepc.v2.api.provider.QueryHandle;
import de.umr.jepc.v2.bridges.nat.NativeBridge;
import de.umr.jepc.v2.provider.def.DefaultEPProvider;

/**
 * @author Michael Körber
 *
 */
public class TPStreamAdapter implements EngineAdapter {
    
    private EPProvider provider;
    
    private EventGenerator gen;
    
    private CountingSink sink;
    
    private ExternalStreamHandle sh;
    private QueryHandle qh;
    
    public TPStreamAdapter(EventGenerator gen, TPStream query) {
        this.gen = gen;
        provider = new DefaultEPProvider( new NativeBridge() ); 
        
        try {
            sh = provider.registerExternalStream(gen.getName(), gen.getSchema());
            qh = provider.createQuery("Q1", query);
            sink = new CountingSink();
            provider.registerSink(qh, sink);
        } catch (EPException e) {
            throw new RuntimeException(e);
        }
    }
    
    public void run() {
        while ( gen.hasNext() ) {
            sh.pushEvent( gen.next() );
        }
    }
    
    public long getNumberOfResults() {
        return sink.count;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void destroy() {
        provider.destroy();
        
    }
    
    

}
