package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.generator;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.EVEvent;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.EventGenerator;

public class RepeatableEventGenerator implements EventGenerator {
	
	private final List<EVEvent> store;
	
	private Iterator<EVEvent> iter;
	
	private final EventSchema schema;
	
	private final String name;
	
	public RepeatableEventGenerator(EventGenerator input) {
		this.store   = new ArrayList<>();
		this.name = input.getName();
		this.schema = input.getSchema();
		while ( input.hasNext() ) {
			store.add(input.next() );
		}
		this.iter = store.iterator();
	}

	public void reset() {
		iter = store.iterator();
	}

	@Override
	public boolean hasNext() {
		return iter.hasNext();
	}

	@Override
	public EVEvent next() {
		return iter.next();
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EventSchema getSchema() {
        return schema;
    }

}
