package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.generator;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.SituationGenerator;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.situations.Situation;

public class RepeatableSituationGenerator implements SituationGenerator {
	
	private final List<Situation> store;
	
	private Iterator<Situation> iter;
	
	private final int numSits;
	
	private final String name;
	
	public RepeatableSituationGenerator(SituationGenerator input) {
		this.store = new ArrayList<>();
		this.numSits = input.getNumberOfSituations();
		this.name = input.getName();
		while ( input.hasNext() ) {
			store.add(input.next() );
		}
		this.iter = store.iterator();
	}

	public void reset() {
		iter = store.iterator();
	}

	@Override
	public boolean hasNext() {
		return iter.hasNext();
	}

	@Override
	public Situation next() {
		return iter.next();
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getNumberOfSituations() {
        return numSits;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String getName() {
        return name;
    }

}
