package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.data.situations.duration;

import java.util.Random;

public class UniformDurationGenerator implements DurationGenerator {
	
	public final int min;
	
	public final int max;
	
	private final int span;
	
	public UniformDurationGenerator(int min, int max) {
		this.min = Math.max(min,1);
		this.max = Math.max(max,this.min+1);
		this.span = max-min;
	}

	@Override
	public int nextDuration(Random rand) {
		return rand.nextInt(span+1) + min;
	}
}
