/**
 * 
 */
package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.iseq;

import de.umr.ep.common.EPException;
import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.addons.epa.AbstractSituationMatcher;
import de.umr.jepc.v2.addons.epa.tpstream.SituationDefinitions;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.iseq.synthetic.SyntheticISEQFactory;
import de.umr.jepc.v2.addons.epa.tpstream.matcher.Matcher.MatcherCallback;
import de.umr.jepc.v2.addons.epa.tpstream.partition.PartitionFactory;
import de.umr.jepc.v2.api.epa.EPA;
import de.umr.jepc.v2.api.epa.pattern.Output;
import de.umr.jepc.v2.api.epa.pattern.Partition;

/**
 * @author Michael Körber
 *
 */
public class SyntheticISEQ extends AbstractSituationMatcher {
    
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    /**
     * @param input
     * @param window
     * @param definitions
     * @param output
     * @param partitionBy
     */
    public SyntheticISEQ(EPA input, long window, SituationDefinitions definitions, Output output, Partition partitionBy) {
        super(input, window, definitions, output, partitionBy);
    }
    
    

    public SyntheticISEQ(EPA input, long window, SituationDefinitions definitions, Output output) {
		super(input, window, definitions, output);
	}



	/**
     * {@inheritDoc}
     */
    @Override
    protected PartitionFactory getPartitionFactory(EventSchema schemaIn, MatcherCallback callback) throws EPException {
        return new SyntheticISEQFactory(schemaIn, definitions, window, callback);
    }

}
