/**
 * 
 */
package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.iseq.aggressive;

import de.umr.ep.common.IncompatibleTypeException;
import de.umr.ep.event.EventSchema;
import de.umr.jepc.v2.addons.epa.tpstream.SituationDefinitions;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.iseq.AbstractISEQPartitionFactory;
import de.umr.jepc.v2.addons.epa.tpstream.matcher.Matcher;
import de.umr.jepc.v2.addons.epa.tpstream.matcher.Matcher.MatcherCallback;
import de.umr.jepc.v2.addons.epa.tpstream.partition.deriver.AbstractDeriver;
import de.umr.jepc.v2.addons.epa.tpstream.partition.deriver.ClassicDeriver;
import de.umr.jepc.v2.bindings.EVBindings;
import de.umr.jepc.v2.expressions.bool.EVBooleanExpression;
import de.umr.jepc.v2.ql.TranslatorException;

/**
 * @author Michael Körber
 *
 */
public class AggressiveISEQLightFactory extends AbstractISEQPartitionFactory {

    /**
     * @param schema
     * @param definitions
     * @param window
     * @param callback
     * @throws TranslatorException
     * @throws IncompatibleTypeException
     */
    public AggressiveISEQLightFactory(EventSchema schema, SituationDefinitions definitions, long window, MatcherCallback callback)
            throws TranslatorException, IncompatibleTypeException {
        super(schema, definitions, window, callback);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected AbstractDeriver createDeriver(EVBooleanExpression condition, EVBindings bindings) {
        return new ClassicDeriver(condition, bindings);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Matcher createMatcher(SituationDefinitions definitions, long window, MatcherCallback callback) {
        return new AggressiveISEQLightMatcher(definitions, window, callback);
    }

}
