package de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.iseq.util;

import de.umr.jepc.v2.addons.epa.tpstream.Situation;

public enum TComp {

	TS_LT_TS( (a,b) -> a.getStart() < b.getStart() ),
	TS_LE_TS( (a,b) -> a.getStart() <= b.getStart() ),
	TS_EQ_TS( (a,b) -> a.getStart() == b.getStart() ),
	TS_GE_TS( (a,b) -> a.getStart() >= b.getStart() ),
	TS_GT_TS( (a,b) -> a.getStart() > b.getStart() ),
	
	TS_LT_TE( (a,b) -> a.getStart() < b.getEnd() ),
	TS_LE_TE( (a,b) -> a.getStart() <= b.getEnd() ),
	TS_EQ_TE( (a,b) -> a.getStart() == b.getEnd() ),
	TS_GE_TE( (a,b) -> a.getStart() >= b.getEnd() ),
	TS_GT_TE( (a,b) -> a.getStart() > b.getEnd() ),
	
	TE_LT_TS( (a,b) -> a.getEnd() < b.getStart() ),
	TE_LE_TS( (a,b) -> a.getEnd() <= b.getStart() ),
	TE_EQ_TS( (a,b) -> a.getEnd() == b.getStart() ),
	TE_GE_TS( (a,b) -> a.getEnd() >= b.getStart() ),
	TE_GT_TS( (a,b) -> a.getEnd() > b.getStart() ),
	
	TE_LT_TE( (a,b) -> a.getEnd() < b.getEnd() ),
	TE_LE_TE( (a,b) -> a.getEnd() <= b.getEnd() ),
	TE_EQ_TE( (a,b) -> a.getEnd() == b.getEnd() ),
	TE_GE_TE( (a,b) -> a.getEnd() >= b.getEnd() ),
	TE_GT_TE( (a,b) -> a.getEnd() > b.getEnd() );
	
	static interface Cmp {
		boolean eval( Situation a, Situation b );
	}
	
	
	private final Cmp cmp;

	private TComp(Cmp cmp) {
		this.cmp = cmp;
	}
	
	public boolean applies( Situation a, Situation b ) {
		return cmp.eval(a, b);
	}
	
	
	
}
