/**
 * 
 */
package de.umr.jepc.v2.addons.epa.tpstream.partition.deriver;

import de.umr.jepc.v2.addons.epa.tpstream.Situation;
import de.umr.jepc.v2.addons.epa.tpstream.evaluation.util.WallTime;

/**
 * @author mika
 *
 */
public class MSituation extends Situation {
	
	private long wallStart;
	
	private long wallEnd;

	/**
	 * Creates a new MSituation instance
	 * @param start
	 * @param end
	 * @param numBindings
	 */
	public MSituation(long start, long end, int numBindings) {
		super(start, end, numBindings);
		wallStart = wallEnd = WallTime.getLastTimestamp();
	}

	/**
	 * Creates a new MSituation instance
	 * @param start
	 * @param end
	 */
	public MSituation(long start, long end) {
		super(start, end);
		wallStart = wallEnd = WallTime.getLastTimestamp();
	}

	/**
	 * @{inheritDoc}
	 */
	@Override
	public void update(long end) {
		super.update(end);
		wallEnd = WallTime.getLastTimestamp();
	}
	
	/**
	 * @{inheritDoc}
	 */
	@Override
	public void finish(long end) {
		super.finish(end);
		wallEnd = WallTime.getLastTimestamp();
	}

	/**
	 * @return the wallStart
	 */
	public long getWallStart() {
		return this.wallStart;
	}
	
	/**
	 * @return the wallEnd
	 */
	public long getWallEnd() {
		return this.wallEnd;
	}
	
	
	
	


}
