/**
 * 
 */
package de.umr.jepc.v2.addons.epa.tpstream.partition.deriver;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.bindings.EVBindings;
import de.umr.jepc.v2.expressions.bool.EVBooleanExpression;

/**
 * @author mika
 *
 */
public class MeasuringISEQDeriver extends AbstractDeriver {
	
	/** The situation currently constructed */
    private MSituation current;

	/**
	 * Creates a new MeasuringISEQDeriver instance
	 * @param condition
	 * @param aggregates
	 */
	public MeasuringISEQDeriver(EVBooleanExpression condition, EVBindings aggregates) {
		super(condition, aggregates);
	}

	/**
     * @{inheritDoc}
     */
    public MSituation update(Event event) {
    	MSituation result = null;

        // Expression is OK
        if (condition.eval(event)) {
            // Start a new situation
            if (current == null) {
                current = new MSituation(event.getT1(), event.getT2(), aggregates.getNumberOfBindings());
                updateAggregates(event, current, true);
            }
            // Update the current situation
            else {
                current.update(event.getT2());
                updateAggregates(event, current, false);
            }
        }
        // If we had a current situation -> Close it
        else if (current != null) {
            current.finish(event.getT1());
            result = current;
            current = null;
        }
        return result;
    }

}
