/**
 * 
 */
package de.umr.jepc.v2.addons.epa.tpstream.partition.deriver;

import de.umr.ep.event.Event;
import de.umr.jepc.v2.bindings.EVBindings;
import de.umr.jepc.v2.expressions.bool.EVBooleanExpression;

/**
 * @author mika
 *
 */
public class MeasuringLLDeriver extends AbstractDeriver {

	/** The situation currently constructed */
    private MSituation current;
    
    /**
     * @param condition the condition to evaluate on incoming events
     * @param aggregates the aggregates to compute for each situation
     */
    public MeasuringLLDeriver(EVBooleanExpression condition, EVBindings aggregates) {
        super(condition, aggregates);
    }
    
    /**
     * @{inheritDoc}
     */
    public MSituation update(Event event) {
        MSituation result = null;

        // Expression is OK
        if (condition.eval(event)) {
            // Start a new situation
            if (current == null) {
                current = new MSituation(event.getT1(), event.getT2(), aggregates.getNumberOfBindings());
                updateAggregates(event, current, true);
                result = current;
            }
            // Update the current situation
            else {
                current.update(event.getT2());
                updateAggregates(event, current, false);
            }
        }
        // If we had a current situation -> finish it
        else if (current != null) {
            current.finish(event.getT1());
            result = current;
            current = null;
        }
        return result;
    }
}
